VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const m_Syntax As String = "Microsoft Macro Assembler"
Private Const m_Version As String = "3.00"

Private m_Expl_Const As Boolean
Private m_Insert_After_Option As Boolean
Private m_ShowParams As Boolean
Private m_AutoFormat As Boolean
Private m_Type As String
Public m_Charset As Long

Public Property Let Charset(mCharset)
    m_Charset = mCharset
End Property

Public Property Get VarRanges() As Boolean
    VarRanges = False
End Property

Public Sub mNoRange()
    m_Type = ""
End Sub

Public Sub mPublic()
    m_Type = ""
End Sub

Public Sub mPrivate()
    m_Type = ""
End Sub

Public Property Get Version() As String
    Version = m_Version
End Property

Public Property Get Syntax() As String
    Syntax = m_Syntax
End Property

Public Function InitPlugIn() As Boolean
    'Return True if Init is successful
    InitPlugIn = True
End Function

Public Property Get ShowParams() As Boolean
    'Only needed for MASM
    ShowParams = True
End Property

Public Property Let ShowParams(m_Use_ShowParams As Boolean)
    m_ShowParams = m_Use_ShowParams
End Property

Public Property Get AutoFormat() As Boolean
    'Return True if the programming langauge
    'supports Declarations in more than one line
    AutoFormat = False
End Property

Public Property Let AutoFormat(m_Use_AutoFormat As Boolean)
    m_AutoFormat = m_Use_AutoFormat
End Property

Public Property Get ExplConst() As Boolean
    ExplConst = False
End Property

Public Property Let ExplConst(m_Use_Expl_Const As Boolean)
    m_Expl_Const = m_Use_Expl_Const
End Property

Public Function GetType(ByVal m_Name As String, ByVal m_Data As String) As String
    m_Data = Replace(m_Data, "As Long", Chr$(9) & "DWORD" & Chr$(9) & "?")
    m_Data = Replace(m_Data, "As Byte", Chr$(9) & "BYTE" & Chr$(9) & "?")
    m_Data = Replace(m_Data, "As Single", Chr$(9) & "REAL4" & Chr$(9) & "?")
    m_Data = Replace(m_Data, "As Double", Chr$(9) & "REAL8" & Chr$(9) & "?")
    m_Data = Replace(m_Data, "As Integer", Chr$(9) & "WORD" & Chr$(9) & "?")
    m_Data = Replace(m_Data, "As", Chr$(9))
    m_Data = Replace(m_Data, " String *", "BYTE")
    GetType = m_Name & " STRUCT" & vbNewLine & m_Data & vbNewLine & m_Name & " ENDS"
End Function

Public Function GetEnum(ByVal m_Name As String, ByVal m_Data As String) As String
    GetEnum = "Not Supported"
End Function

Public Function GetConst(m_Name As String, m_Data As String) As String
    Dim m_Text As String
    m_Text = m_Data
    If InStr(m_Text, "&H") > 0 Then
        m_Text = m_Text & "h"
        m_Text = Replace(m_Text, "&H", "")
    End If
    GetConst = m_Name & " equ " & m_Text
End Function

Public Function GetSub(m_Name As String, m_Data As String) As String
    GetSub = FormatDec(m_Name, m_Data)
End Function

Public Function GetFunc(m_Name As String, m_Data As String) As String
    GetFunc = FormatDec(m_Name, m_Data)
End Function

Public Property Let InsertAfterOption(m_Use_Insert_After_Option As Boolean)
    m_Insert_After_Option = m_Use_Insert_After_Option
End Property

Public Property Get InsertAfterOption() As Boolean
    InsertAfterOption = False
End Property

Private Function FormatDec(m_Name As String, m_Data As String) As String
    Dim tmp As String
    Dim x As Long
    Dim test() As String
    Dim i As Long
    Dim res As String
    x = InStr(m_Data, ")") - 1
    If x > 0 Then tmp = Left$(m_Data, InStr(m_Data, ")") - 1)
    x = InStr(m_Data, ")") - 1
    If x > 0 Then tmp = Right$(tmp, Len(tmp) - InStr(tmp, "("))
    tmp = Replace(tmp, "&", ",:DWORD")
    tmp = Replace(tmp, "%", ",:WORD")
    tmp = Replace(tmp, "$", ",:DWORD")
    tmp = Replace(tmp, "String", "DWORD")
    tmp = Replace(tmp, "):", "),")
    tmp = Replace(tmp, "~", "")
    tmp = Replace(tmp, " As ", ",:")
    tmp = Replace(tmp, "Any", "DWORD")
    tmp = Replace(tmp, "Variant", "DWORD")
    tmp = Replace(tmp, "?", "")
    tmp = Replace(tmp, "(:", "(),")
    test = Split(tmp, ",")
    For i = 0 To UBound(test())
        If i > 1 And i Mod 2 <> 0 Then res = res & ","
        If m_ShowParams Then
            If i Mod 2 <> 0 Then
                res = res & test(i)
            Else
                res = res & " {" & LTrim$(test(i)) & "}"
            End If
        Else
            If i Mod 2 <> 0 Then
                res = res & test(i)
            End If
        End If
    Next i
    If Not m_ShowParams Then res = " " & res
    FormatDec = m_Name & " PROTO" & res
End Function

Public Function Preview() As String
    Dim strTemp As String
    If m_ShowParams Then
        strTemp = "Test PROTO {Param1}:DWORD,{Param2}:DWORD,{Param3}:DWORD,{Param4}:DWORD"
    Else
        strTemp = "Test PROTO :DWORD,:DWORD,:DWORD,:DWORD"
    End If
    Preview = strTemp
End Function
